diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index c0ef84e18..93f52d515 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -1688,26 +1709,26 @@ public class RenderGlobal
     @Override
     public void blockChanged(int x, int y, int z)
     {
-        markDirty(x - 1, y - 1, z - 1, x + 1, y + 1, z + 1);
+        setDirty(x - 1, y - 1, z - 1, x + 1, y + 1, z + 1);
     }
 
     @Override
     public void setBlocksDirty(int x0, int y0, int z0, int x1, int y1, int z1)
     {
-        markDirty(x0 - 1, y0 - 1, z0 - 1, x1 + 1, y1 + 1, z1 + 1);
+        setDirty(x0 - 1, y0 - 1, z0 - 1, x1 + 1, y1 + 1, z1 + 1);
     }
 
-    public void clipRenderersByFrustum(CameraFrustum frustum, float partialTick)
+    public void cull(CameraFrustum frustum, float partialTick)
     {
         for(int i = 0; i < chunkRenderers.length; i++)
         {
-            if(!chunkRenderers[i].isEmpty() && (!chunkRenderers[i].visible || (i + frustumCheckOffset & 0xf) == 0))
+            if(!chunkRenderers[i].isEmpty() && (!chunkRenderers[i].visible || (i + cullStep & 0xf) == 0))
             {
                 chunkRenderers[i].cull(frustum, partialTick);
             }
         }
 
-        frustumCheckOffset++;
+        cullStep++;
     }
 
     @Override
@@ -1751,7 +1772,7 @@ public class RenderGlobal
         {
             return;
         }
-        Particle fx = ParticleDispatcher.getInstance().getDispatch(particleId).newParticle(worldObj, x, y, z, motionX, motionY, motionZ, data);
+        Particle fx = ParticleDispatcher.getInstance().getDispatch(particleId).newParticle(world, x, y, z, motionX, motionY, motionZ, data);
         if (fx != null){
             mc.particleEngine.add(fx);
         }
@@ -1765,7 +1786,7 @@ public class RenderGlobal
 		if(seasonChanged || lightChanged && !LightmapHelper.isLightmapEnabled()) {
 			for(ChunkRenderer chunkRenderer : chunkRenderers) {
 				if(chunkRenderer.skyLit && !chunkRenderer.dirty) {
-					chunkRenderersToUpdate.add(chunkRenderer);
+					dirtyChunks.add(chunkRenderer);
 					chunkRenderer.setDirty();
 				}
 			}
@@ -1777,30 +1798,30 @@ public class RenderGlobal
     {
     }
 
-    public void deleteRenderListBase()
+    public void deleteChunkLists()
     {
-        if (glRenderListBase >= 0) {
-            GLAllocation.deleteDisplayList(glRenderListBase);
+        if (chunkLists >= 0) {
+            GLAllocation.deleteDisplayList(chunkLists);
         }
     }
     @Override
     public void levelEvent(Player player, int id, int x, int y, int z, int data)
     {
-        Random random = worldObj.rand;
+        Random random = world.rand;
         switch(id) {
             default:
                 break;
 
             case EVENT_DISPENSER_EMPTY: // Dispenser empty click
-                worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x, y, z, "tile.dispenser.click", 1.0F, 1.0F);
+                world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x, y, z, "tile.dispenser.click", 1.0F, 1.0F);
                 break;
 
             case EVENT_DISPENSER_ITEM: // Dispenser fire item
-                worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x, y, z, "tile.dispenser.eject", 1.0F, 1.0F);
+                world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x, y, z, "tile.dispenser.eject", 1.0F, 1.0F);
                 break;
 
             case EVENT_DISPENSER_PROJECTILE: // Dispenser fire projectile
-                worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x, y, z, "tile.dispenser.fire", 1.0F, 1.2F);
+                world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x, y, z, "tile.dispenser.fire", 1.0F, 1.2F);
                 break;
 
             case EVENT_DISPENSER_PARTICLES: // Dispenser eject particles
@@ -1828,36 +1849,36 @@ public class RenderGlobal
                 if(data > 0) {
                     Block<?> block = Blocks.blocksList[data];
 
-                    worldObj.playBlockSoundEffect(null, (float)x + 0.5F, (float)y + 0.5F, (float)z + 0.5F, block, EnumBlockSoundEffectType.MINE);
+                    world.playBlockSoundEffect(null, (float)x + 0.5F, (float)y + 0.5F, (float)z + 0.5F, block, EnumBlockSoundEffectType.MINE);
                 }
-                mc.particleEngine.destroy(x, y, z, data, worldObj.getBlockMetadata(x, y, z));
+                mc.particleEngine.destroy(x, y, z, data, world.getBlockMetadata(x, y, z));
                 break;
 
             case EVENT_DOOR_SOUND: // Door sound
                 if(java.lang.Math.random() < 0.5D) {
-                    worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5D, (double)y + 0.5D, (double)z + 0.5D, "random.door_open", 1.0F, worldObj.rand.nextFloat() * 0.1F + 0.9F);
+                    world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5D, (double)y + 0.5D, (double)z + 0.5D, "random.door_open", 1.0F, world.rand.nextFloat() * 0.1F + 0.9F);
                 } else {
-                    worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5D, (double)y + 0.5D, (double)z + 0.5D, "random.door_close", 1.0F, worldObj.rand.nextFloat() * 0.1F + 0.9F);
+                    world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5D, (double)y + 0.5D, (double)z + 0.5D, "random.door_close", 1.0F, world.rand.nextFloat() * 0.1F + 0.9F);
                 }
                 break;
 
             case EVENT_FIRE_EXTINGUISH: // Fire extinguish sound
-                worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (float)x + 0.5F, (float)y + 0.5F, (float)z + 0.5F, "random.fizz", 0.5F, 2.6F + (random.nextFloat() - random.nextFloat()) * 0.8F);
+                world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (float)x + 0.5F, (float)y + 0.5F, (float)z + 0.5F, "random.fizz", 0.5F, 2.6F + (random.nextFloat() - random.nextFloat()) * 0.8F);
                 break;
 
             case EVENT_JUKEBOX_TOGGLE: // Jukebox play/stop record
                 if(Item.itemsList[data] instanceof ItemDiscMusic) {
                     ItemDiscMusic record = ((ItemDiscMusic)Item.itemsList[data]);
-                    worldObj.playRecord(record.recordName, record.recordAuthor, x, y, z);
+                    world.playRecord(record.recordName, record.recordAuthor, x, y, z);
                 } else {
-                    worldObj.playRecord(null, null, x, y, z);
+                    world.playRecord(null, null, x, y, z);
                 }
                 break;
             case EVENT_PISTON_EXTEND: // Piston extend
-                worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5F, (double)y + 0.5F, (double)z + 0.5F, "tile.piston.out", 0.5F, worldObj.rand.nextFloat() * 0.25F + 0.6F);
+                world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5F, (double)y + 0.5F, (double)z + 0.5F, "tile.piston.out", 0.5F, world.rand.nextFloat() * 0.25F + 0.6F);
                 break;
             case EVENT_PISTON_RETRACT: // Piston retract
-                worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5F, (double)y + 0.5F, (double)z + 0.5F, "tile.piston.in", 0.5F, worldObj.rand.nextFloat() * 0.25F + 0.6F);
+                world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5F, (double)y + 0.5F, (double)z + 0.5F, "tile.piston.in", 0.5F, world.rand.nextFloat() * 0.25F + 0.6F);
                 break;
         }
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/TextureManager.java b/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
index 66940ee52..f41b3dc38 100644
--- a/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
@@ -127,9 +127,9 @@ public class TextureManager {
 				assert cNether.hasMeta("animation") : "Coordinate " + cNether.namespaceId + " is expected to have animation data attached!";
 				addDynamicTexture(new DynamicTextureCustom(cNether, cNether.getMeta("animation", AnimationProperties.class)));
 
-				final IconCoordinate cParadise = TextureRegistry.getTexture("minecraft:block/portal_paradise/" + c.colorID);
-				assert cParadise.hasMeta("animation") : "Coordinate " + cParadise.namespaceId + " is expected to have animation data attached!";
-				addDynamicTexture(new DynamicTextureCustom(cParadise, cParadise.getMeta("animation", AnimationProperties.class)));
+				final IconCoordinate cDrift = TextureRegistry.getTexture("minecraft:block/portal_drift/" + c.colorID);
+				assert cDrift.hasMeta("animation") : "Coordinate " + cDrift.namespaceId + " is expected to have animation data attached!";
+				addDynamicTexture(new DynamicTextureCustom(cDrift, cDrift.getMeta("animation", AnimationProperties.class)));
 			}
 		}
 	}
diff --git a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
index fb9713e93..32a4f00ad 100644
--- a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -523,12 +523,14 @@ public class WorldRenderer
             if(mc.gameSettings.enableVsync.value || mc.gameSettings.customFpsLimit.value > 0) // Power saver
             {
                 Debug.change("sleep");
-                long l1 = ((systemTime + (nsPerSecond / c)) - System.nanoTime()) / 1_000_000;
-                if(l1 > 0L && l1 < 500L)
+                long timeToSleep = ((systemTime + (nsPerSecond / c)) - System.nanoTime());
+                long millis = timeToSleep / 1_000_000L;
+                int nanos = (int) (timeToSleep - (millis * 1_000_000L));
+                if(millis > 0L && millis < 500L)
                 {
                     try
                     {
-                        Thread.sleep(l1);
+                        Thread.sleep(millis, nanos);
                     }
                     catch(InterruptedException e)
                     {
@@ -552,7 +554,7 @@ public class WorldRenderer
             if(mc.gameSettings.enableVsync.value || mc.gameSettings.customFpsLimit.value > 0)
             {
                 Debug.change("sleep");
-                long l2 = ((systemTime + (long)(0x3b9aca00 / c)) - System.nanoTime()) / 0xf4240L;
+                long l2 = ((systemTime + (long)(1_000_000_000L / c)) - System.nanoTime()) / 1_000_000L;
                 if(l2 < 0L)
                 {
                     l2 += 10L;
@@ -644,7 +646,7 @@ public class WorldRenderer
             fogManager.setupFog(FogManager.FOG_MODE_SKY, farPlaneDistance, partialTicks);
             glDisable(GL_FOG);
 
-            renderGlobal.drawSky(partialTicks);
+            renderGlobal.renderSky(partialTicks);
         }
         
         Debug.change("misc");
@@ -655,7 +657,7 @@ public class WorldRenderer
             glShadeModel(GL11.GL_SMOOTH);
         }
         
-        mc.renderGlobal.clipRenderersByFrustum(mc.activeCamera.getFrustum(), partialTicks);
+        mc.renderGlobal.cull(mc.activeCamera.getFrustum(), partialTicks);
 
         Debug.change("aurora");
         if (mc.gameSettings.aurora.value && WorldTypeFXDispatcher.getInstance().getDispatch(mc.currentWorld.getWorldType()).hasAurora())
@@ -669,15 +671,15 @@ public class WorldRenderer
         	loops = 40;
         }
         for(int i=0; i < loops; i++) {
-            long l1;
+            long timeRemaining;
             do
             {
-                if(mc.renderGlobal.updateRenderers(mc.activeCamera) || updateRenderersUntil == 0L)
+                if(mc.renderGlobal.updateDirtyChunks(mc.activeCamera) || updateRenderersUntil == 0L)
                 {
                     break;
                 }
-                l1 = updateRenderersUntil - System.nanoTime();
-            } while(l1 >= 0L && l1 <= nsPerSecond);
+                timeRemaining = updateRenderersUntil - System.nanoTime();
+            } while(timeRemaining >= 0L && timeRemaining <= nsPerSecond);
         }
 
         fogManager.setupFog(FogManager.FOG_MODE_NORMAL, farPlaneDistance, partialTicks);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 3080645cf..a1b152b1c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -751,7 +751,7 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelStandard<>(Blocks.GLOWSTONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/glowstone"));
 
         addDispatch(new BlockModelPortal<>(Blocks.PORTAL_NETHER, "minecraft:block/portal_nether/").setAllTextures(BLOCK_TEXTURES, "minecraft:block/portal_nether"));
-        addDispatch(new BlockModelPortal<>(Blocks.PORTAL_PARADISE, "minecraft:block/portal_paradise/").setAllTextures(BLOCK_TEXTURES, "minecraft:block/portal_nether"));
+        addDispatch(new BlockModelPortal<>(Blocks.PORTAL_DRIFT, "minecraft:block/portal_drift/").setAllTextures(BLOCK_TEXTURES, "minecraft:block/portal_nether"));
 
         addDispatch(new BlockModelCake<>(Blocks.CAKE)
             .setTex(BLOCK_TEXTURES, "minecraft:block/cake/top", Side.TOP)
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererDeer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererDeer.java
index d82bf3db4..c7309ae4b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererDeer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererDeer.java
@@ -14,6 +14,12 @@ public class MobRendererDeer extends MobRenderer<MobDeer> {
         super(shadowSize);
     }
 
+    @Override
+    protected void preRenderTransform(@NotNull final MobDeer entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
+        super.preRenderTransform(entity, x, y, z, yaw, partialTick);
+        GL11.glScalef(1.1F, 1.1F, 1.1F);
+    }
+
     @Override
     protected @Nullable StaticEntityModel getAndSetupModelForLayer(@NotNull final MobDeer entity, final float brightness, final float partialTick, final int layer) {
         final StaticEntityModel model = getModel("main");
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
index bda5a26b6..180426e20 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
@@ -377,10 +377,10 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
             .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
         addDispatch(new ItemModelStandard(Items.DOOR_STEEL, "minecraft"));
         addDispatch(new ItemModelPaintbrush(Items.PAINTBRUSH, "minecraft")
-            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
-            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
-            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
-            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND,  new DisplayPos(1.13f/16f, 3.2f/16f, 1.13f/16f, 90, -90, 25, 0.68f, 0.68f, 0.68f))
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, new DisplayPos(1.13f/16f, 3.2f/16f, 1.13f/16f, 90, 90, -25, 0.68f, 0.68f, 0.68f))
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, new DisplayPos(0, 4.0f/16f, 0.5f/16f, 90, -90, 55, 0.85f, 0.85f, 0.85f))
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, new DisplayPos(0, 4.0f/16f, 0.5f/16f, 90,  90, -55, 0.85f, 0.85f, 0.85f)));
 
         addDispatch(new ItemModelStandard(Items.RECORD_13, "minecraft"));
         addDispatch(new ItemModelStandard(Items.RECORD_CAT, "minecraft"));
@@ -400,7 +400,7 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
         addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.GLOWSTONE.asItem()).setFullBright());
         addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.PUMPKIN_CARVED_ACTIVE.asItem()).setFullBright());
         addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.LAMP_ACTIVE.asItem()).setFullBright());
-        addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.PORTAL_PARADISE.asItem()).setFullBright());
+        addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.PORTAL_DRIFT.asItem()).setFullBright());
         addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.PORTAL_NETHER.asItem()).setFullBright());
 
         addDispatch(new ItemModelStandard(Items.JAR_BUTTERFLY_BLUE, "minecraft"));
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererLegacy.java b/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererLegacy.java
index b14ad2712..933f981f3 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererLegacy.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererLegacy.java
@@ -17,23 +17,23 @@ public class TerrainRendererLegacy extends TerrainRenderer {
 
 	@Override
 	public void renderSolidTerrain(float partialTicks) {
-        mc.renderGlobal.sortAndRender(mc.activeCamera, 0, partialTicks);
+        mc.renderGlobal.render(mc.activeCamera, 0, partialTicks);
 	}
 
 	@Override
 	public void renderTranslucentTerrain(float partialTicks) {
 		RenderGlobal renderGlobal = mc.renderGlobal;
 		if(mc.gameSettings.fancyGraphics.value == 0) {
-			renderGlobal.sortAndRender(mc.activeCamera, 1, partialTicks);
+			renderGlobal.render(mc.activeCamera, 1, partialTicks);
 			return;
 		}
 		
 		glColorMask(false, false, false, false);
-		int renderCount = renderGlobal.sortAndRender(mc.activeCamera, 1, partialTicks);
+		int renderCount = renderGlobal.render(mc.activeCamera, 1, partialTicks);
 		glColorMask(true, true, true, true);
 		
 		if(renderCount > 0) {
-			renderGlobal.callAllDisplayLists(1, partialTicks);
+			renderGlobal.renderSameAsLast(1, partialTicks);
 		}
 	}
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java b/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java
index cfb6debe9..44a612fda 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java
@@ -80,7 +80,7 @@ public class TerrainRendererMultiDraw extends TerrainRenderer {
 			int y = MathHelper.floor(renderPosY);
 			int z = MathHelper.floor(renderPosZ);
 			
-			mc.renderGlobal.markRenderersForNewPosition(x, y, z);
+			mc.renderGlobal.resortChunks(x, y, z);
 		}
 		
 		if(terrainVertexConfig == null) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
index d1f26d2ba..712769d54 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
@@ -99,7 +99,7 @@ public class TexturePackList
 
 	public void refresh(){
 		mc.textureManager.refreshTexturesAndDisplayErrors();
-		mc.renderGlobal.loadRenderers();
+		mc.renderGlobal.allChanged();
 		if (mc.currentScreen != null) {
 			mc.currentScreen.updateFont();
 		}
diff --git a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXDispatcher.java
index 42e8ea491..4ce89e1cf 100644
--- a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXDispatcher.java
@@ -1,7 +1,6 @@
 package net.minecraft.client.render.worldtype;
 
 import net.minecraft.client.util.dispatch.Dispatcher;
-import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.type.WorldTypes;
 
@@ -32,7 +31,7 @@ public class WorldTypeFXDispatcher extends Dispatcher<WorldType, WorldTypeFX> {
             .setHasAurora(true)
             .setCloudHeight(128f - 20f));
         addDispatch(new WorldTypeFXOverworld(WorldTypes.OVERWORLD_RETRO)
-            .setHasAurora(true));
+            .setHasAurora(false));
         addDispatch(new WorldTypeFXOverworld(WorldTypes.OVERWORLD_ISLANDS)
             .setHasAurora(true));
         addDispatch(new WorldTypeFXOverworld(WorldTypes.OVERWORLD_WINTER)
@@ -49,9 +48,12 @@ public class WorldTypeFXDispatcher extends Dispatcher<WorldType, WorldTypeFX> {
             .setHasAurora(true));
         addDispatch(new WorldTypeFXOverworld(WorldTypes.OVERWORLD_SKYBLOCK)
             .setHasAurora(true));
+        addDispatch(new WorldTypeFXOverworld(WorldTypes.OVERWORLD_BETA_173)
+            .setHasAurora(false));
         addDispatch(new WorldTypeFX(WorldTypes.OVERWORLD_HELL));
 
         addDispatch(new WorldTypeFX(WorldTypes.FLAT)
+            .setHasAurora(false)
             .setCloudHeight(256f - 20f));
 
         addDispatch(new WorldTypeFXNether(WorldTypes.NETHER_DEFAULT)
@@ -61,7 +63,7 @@ public class WorldTypeFXDispatcher extends Dispatcher<WorldType, WorldTypeFX> {
             .setHasClouds(false)
             .setHasSky(false));
 
-        addDispatch(new WorldTypeFXParadise(WorldTypes.PARADISE_DEFAULT)
+        addDispatch(new WorldTypeFXDrift(WorldTypes.DRIFT_DEFAULT)
             .setCloudHeight(8f)
             .setHasGround(false));
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXParadise.java b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXDrift.java
similarity index 95%
rename from game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXParadise.java
rename to game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXDrift.java
index d43b8b23d..5852c737a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXParadise.java
+++ b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXDrift.java
@@ -6,8 +6,8 @@ import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.type.WorldType;
 
-public class WorldTypeFXParadise extends WorldTypeFX{
-    public WorldTypeFXParadise(WorldType worldType) {
+public class WorldTypeFXDrift extends WorldTypeFX{
+    public WorldTypeFXDrift(WorldType worldType) {
         super(worldType);
     }
 
diff --git a/game/core/build.gradle.kts b/game/core/build.gradle.kts
index 90b5c0cbd..926dc3843 100644
--- a/game/core/build.gradle.kts
+++ b/game/core/build.gradle.kts
@@ -1,3 +1,4 @@
+import org.gradle.internal.impldep.org.bouncycastle.util.Integers
 import java.util.*
 
 plugins {
@@ -5,10 +6,10 @@ plugins {
 }
 
 group = providers.gradleProperty("bta.group").get()
-version = providers.gradleProperty("bta.version").get()
+var version: String = providers.gradleProperty("bta.version").get()
 val assetPackFormat = providers.gradleProperty("bta.assetPackFormat").get()
 val buildChannel = providers.gradleProperty("bta.buildChannel").get()
-val mpProtocolVersion = providers.gradleProperty("bta.mpProtocolVersion").get()
+//val mpProtocolVersion = providers.gradleProperty("bta.mpProtocolVersion").get()
 
 run {
     val file = File("version.txt")
@@ -49,6 +50,8 @@ java {
 
 //region Tasks
 val versionGenerator by tasks.registering {
+    outputs.upToDateWhen { false }
+
     group = "bta.generator"
     val versionDir = project.layout.buildDirectory.dir("generated/sources/version/java")
     val outputFile = versionDir.get().file("net/minecraft/core/Version.java").asFile
@@ -59,19 +62,70 @@ val versionGenerator by tasks.registering {
         outputFile.writeText(
                 """
                     package net.minecraft.core;
-                    
+
                     public final class Version {
                         public static final String VERSION = "$version";
                         public static final long BUILD_TIME = ${Date().time}L;
                         public static final int ASSET_PACK_FORMAT = $assetPackFormat;
                         public static final BuildChannel BUILD_CHANNEL = $buildChannel;
-                        public static final int MP_PROTOCOL_VERSION = $mpProtocolVersion;
+                        public static final int MP_PROTOCOL_VERSION = ${genProtocol(version, buildChannel)};
                     }
                 """.trimIndent()
         )
     }
 }
 
+// Protocol version scheme:
+// 2 byte value
+// 1st nibble: Major version
+// 2nd nibble: Minor version
+// 3rd nibble: 0 if release, 1 if prerelease, 2 if nightly/dev release
+// 4th nibble: Prerelease version or patch version
+// For example, 7.1_01 would be encoded as 0x7101
+// 7.1 prerelease 1 would be encoded as 0x7111
+fun genProtocol(version: String, channel: String): String {
+    val parts = version.split(".") // 7.3_01
+    var major = 0;
+    var minor = 0;
+    var patch = 0;
+    val chn = when(channel.removePrefix("BuildChannel.")) {
+        "RELEASE" -> 0
+        "PRERELEASE" -> 1
+        "DEVELOPMENT" -> 2
+        "NIGHTLY" -> 2
+        else -> {
+            2
+        }
+    }
+
+    if (channel == "BuildChannel.NIGHTLY") {
+        major = 0xF;
+        minor = 0xF;
+        patch = 0;
+    } else if (parts.isNotEmpty()) {
+        major = parts[0].trim().toInt()
+        if (parts.size > 1) {
+            if (parts[1].contains("_")) {
+                val parts2 = parts[1].split("_")
+                minor = parts2[0].trim().toInt()
+                patch = parts2[1].trim().toInt()
+            } else if (parts[1].contains("prerelease", true)) {
+                val parts2 = parts[1].lowercase().split("prerelease")
+                minor = parts2[0].trim().toInt()
+                patch = parts2[1].trim().toInt()
+            } else if (parts[1].contains("pre", true)) {
+                val parts2 = parts[1].lowercase().split("pre")
+                minor = parts2[0].trim().toInt()
+                patch = parts2[1].trim().toInt()
+            } else {
+                minor = parts[1].trim().toInt()
+            }
+        }
+    }
+
+    return "0x" + Integer.toHexString(major) + Integer.toHexString(minor) + Integer.toHexString(chn) + Integer.toHexString(patch)
+}
+
 tasks.withType(JavaCompile::class.java) {
     options.isIncremental = false
     options.encoding = "UTF-8"
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBedrock.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBedrock.java
index f2df63cd7..dc2cb5902 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBedrock.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBedrock.java
@@ -16,7 +16,7 @@ public class BlockLogicBedrock
 	public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
         if (world.getBlockId(x, y - 1, z) == Blocks.GLOWSTONE.id()) {
-            Blocks.PORTAL_PARADISE.getLogic().tryToCreatePortal(world, x, y, z, DyeColor.SILVER);
+            Blocks.PORTAL_DRIFT.getLogic().tryToCreatePortal(world, x, y, z, DyeColor.SILVER);
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumice.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumice.java
index dc255f166..d05c07b32 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumice.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumice.java
@@ -22,7 +22,7 @@ public class BlockLogicPumice extends BlockLogic {
     {
         super.onBlockPlacedByWorld(world, x, y, z);
         byte radius = 2;
-        if(isWet && (inWater(world, x, y, z) || world.dimension.id == Dimension.PARADISE.id)){
+        if(isWet && (inWater(world, x, y, z) || world.dimension.id == Dimension.DRIFT.id)){
             world.setBlockWithNotify(x, y, z, Blocks.PUMICE_DRY.id());
             world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x + 0.5D, y + 0.5D, z + 0.5D, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
             for(int l = 0; l < 8; l++)
diff --git a/game/core/src/main/java/net/minecraft/core/block/Blocks.java b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
index d3b4d5984..8c0611d23 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
@@ -22,7 +22,6 @@ import net.minecraft.core.item.block.ItemBlockPainted;
 import net.minecraft.core.item.block.ItemBlockStairsPainted;
 import net.minecraft.core.item.block.ItemBlockLamp;
 import net.minecraft.core.item.block.ItemBlockSlabPainted;
-import net.minecraft.core.sound.BlockSound;
 import net.minecraft.core.sound.BlockSounds;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.world.Dimension;
@@ -1117,7 +1116,7 @@ public final class Blocks {
     public static final Block<BlockLogicPortal> PORTAL_NETHER = register("portal.nether", "minecraft:block/portal_nether", 830, (BlockLogicSupplier<BlockLogicPortal>) b -> new BlockLogicPortal(b, Dimension.NETHER, Blocks.OBSIDIAN, Blocks.FIRE))
         .withSound(BlockSounds.GLASS).withHardness(-1F).withLightEmission(0.75F).withOverrideColor(MaterialColor.paintedPurple).withDisabledStats()
         .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.NOT_IN_CREATIVE_MENU);
-    public static final Block<BlockLogicPortal> PORTAL_PARADISE = register("portal.paradise", "minecraft:block/portal_paradise", 831, (BlockLogicSupplier<BlockLogicPortal>) b -> new BlockLogicPortal(b, Dimension.PARADISE, Blocks.GLOWSTONE, Blocks.BEDROCK))
+    public static final Block<BlockLogicPortal> PORTAL_DRIFT = register("portal.drift", "minecraft:block/portal_drift", 831, (BlockLogicSupplier<BlockLogicPortal>) b -> new BlockLogicPortal(b, Dimension.DRIFT, Blocks.GLOWSTONE, Blocks.BEDROCK))
         .withSound(BlockSounds.GLASS).withHardness(-1F).withLightEmission(0.75f).withOverrideColor(MaterialColor.paintedPurple).withDisabledStats()
         .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.NOT_IN_CREATIVE_MENU);
 
diff --git a/game/core/src/main/java/net/minecraft/core/data/legacy/LegacyBiomes.java b/game/core/src/main/java/net/minecraft/core/data/legacy/LegacyBiomes.java
index 37972feb7..50d0fb1ad 100644
--- a/game/core/src/main/java/net/minecraft/core/data/legacy/LegacyBiomes.java
+++ b/game/core/src/main/java/net/minecraft/core/data/legacy/LegacyBiomes.java
@@ -44,7 +44,7 @@ public abstract class LegacyBiomes
         register(Biomes.OVERWORLD_TUNDRA, 12);
         register(Biomes.OVERWORLD_MEADOW, 13);
         register(Biomes.NETHER_NETHER, 14);
-        register(Biomes.PARADISE_PARADISE, 15);
+        register(Biomes.DRIFT_DRIFT, 15);
         register(Biomes.OVERWORLD_BIRCH_FOREST, 16);
         register(Biomes.OVERWORLD_RETRO, 17);
         register(Biomes.OVERWORLD_HELL, 18);
